﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace XamDataGridCombo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            ObservableCollection<X> ocX = new ObservableCollection<X>();
            ocX.Add(new X() { Amount = new decimal(12.3), Indicator = 1, Name = "name1", Sector = 1 });
            ocX.Add(new X() { Amount = new decimal(22.3), Indicator = 2, Name = "name2", Sector = 2 });
            ocX.Add(new X() { Amount = new decimal(32.3), Indicator = 3, Name = "name3", Sector = 3 });
            this.DataContext = ocX;
        }
    }

    public class ViewModelBase : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
    }

    public class X : ViewModelBase
    {
        private string _name;
        private int _sector;
        private decimal? _amount;
        private int? _indicator;

        public string Name
        {
            get
            {
                return this._name;
            }
            set
            {
                this._name = value;
                OnPropertyChanged("Name");
            }
        }

        public int Sector
        {
            get
            {
                return this._sector;
            }
            set
            {
                this._sector = value;
                OnPropertyChanged("Sector");
            }
        }

        public decimal? Amount
        {
            get
            {
                return this._amount;
            }
            set
            {
                if (this._amount != value)
                {
                    this._amount = value;
                    OnPropertyChanged("Amount");
                }
            }
        }

        public int? Indicator
        {
            get
            {
                return this._indicator;
            }
            set
            {
                if (this._indicator != value)
                {
                    this._indicator = value;
                    OnPropertyChanged("Indicator");
                }
            }
        }
    }

    public class Sectors
    {
        public Dictionary<string, int> CreateSectors()
        {
            Dictionary<string, int> sectors = new Dictionary<string, int>();
            sectors.Add("sector1", 1);
            sectors.Add("sector2", 2);
            sectors.Add("sector3", 3);
            return sectors;
        }
    }

    public class ItemsConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return (value as Dictionary<string,int>).Values.ToList();
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }


}
